using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using TIS.Imaging;

namespace Codec_Property_Page
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
		private System.Windows.Forms.ListBox lstCodecs;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnShowPropertyPage;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			this.lstCodecs = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnShowPropertyPage = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(240, 32);
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.Size = new System.Drawing.Size(48, 40);
			this.icImagingControl1.TabIndex = 0;
			this.icImagingControl1.Visible = false;
			// 
			// lstCodecs
			// 
			this.lstCodecs.Location = new System.Drawing.Point(8, 32);
			this.lstCodecs.Name = "lstCodecs";
			this.lstCodecs.Size = new System.Drawing.Size(200, 173);
			this.lstCodecs.TabIndex = 1;
			this.lstCodecs.SelectedIndexChanged += new System.EventHandler(this.lstCodecs_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Available Codecs";
			// 
			// btnShowPropertyPage
			// 
			this.btnShowPropertyPage.Location = new System.Drawing.Point(224, 184);
			this.btnShowPropertyPage.Name = "btnShowPropertyPage";
			this.btnShowPropertyPage.Size = new System.Drawing.Size(88, 24);
			this.btnShowPropertyPage.TabIndex = 3;
			this.btnShowPropertyPage.Text = "Properties...";
			this.btnShowPropertyPage.Click += new System.EventHandler(this.btnShowPropertyPage_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(320, 214);
			this.Controls.Add(this.btnShowPropertyPage);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lstCodecs);
			this.Controls.Add(this.icImagingControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Codec Property Page";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			lstCodecs.DataSource = icImagingControl1.AviCompressors;
		}
		private void lstCodecs_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			AviCompressor codec = lstCodecs.SelectedItem as AviCompressor;

			if( codec != null )
			{
				btnShowPropertyPage.Enabled = codec.PropertyPageAvailable;
			}
		}
		private void btnShowPropertyPage_Click(object sender, System.EventArgs e)
		{
			AviCompressor codec = lstCodecs.SelectedItem as AviCompressor;

			if( codec != null )
			{
				codec.ShowPropertyPage();
			}		
		}
	}
}
